#include <QQuickWindow>

class CustomWin : public QQuickWindow
{
	Q_OBJECT
	Q_PROPERTY(QRect inputCutout READ inputCutout WRITE setInputCutout NOTIFY inputCutoutChanged)
	Q_PROPERTY(bool inputCutoutEnabled READ inputCutoutEnabled WRITE setInputCutoutEnabled NOTIFY inputCutoutEnabledChanged)

public:
	CustomWin();
	~CustomWin();

	static void registerWithQML();

	QRect inputCutout() const { return _inputCutout; }
	void setInputCutout(const QRect& rect);

	bool inputCutoutEnabled() const { return _inputCutoutEnabled; }
	void setInputCutoutEnabled(bool enable);

signals:
	void inputCutoutChanged();
	void inputCutoutEnabledChanged();

private slots:
	void updateCutoutMask();

private:
	bool _inputCutoutEnabled;
	QRect _inputCutout;
};
